import { Destroy, EqualityChecker } from 'zustand/vanilla';
export declare type StateSelector<T, U> = (state: T) => U;
export declare type StateListener<T> = (state: T) => void;
export interface Subscribe<T> {
    (listener: StateListener<T>): () => void;
    <U>(listener: StateListener<T>, selector?: StateSelector<T, U>, equalityFn?: EqualityChecker<U>): () => void;
}
export interface UseValueStore<T> {
    (): T;
    <U>(selector: StateSelector<T, U>, equalityFn?: EqualityChecker<U>): U;
    getState: any | (() => T);
    subscribe: any | Subscribe<T>;
    destroy: Destroy;
}
declare type HookArgs = any[];
declare type HookReturnsState<TState> = (...any: HookArgs) => TState;
export default function create<TState>(hook: HookReturnsState<TState>, ...hookArgs: HookArgs): UseValueStore<TState>;
export {};
